Skip to content

List Network Interface.

GET
/api/config/namespaces/{namespace}/network_interfaces
curl --request GET \
--url https://example-corp.console.ves.volterra.io/api/v1/api/production/us-east-1/namespaces/default/api/config/namespaces/example/network_interfaces \
--header 'Authorization: <Authorization>'

List the set of network_interface in a namespace.

Examples of this operation.

namespace
required
string

Namespace Namespace to scope the listing of network_interface.

label_filter
string

A LabelSelectorType expression that every item in list response will satisfy.

report_fields
Array<string>

X-example: "" Extra fields to return along with summary fields.

report_status_fields
Array<string>

X-example: "" Extra status fields to return along with summary fields.

A successful response.

Media typeapplication/json
ListResponse is the collection of network_interface

This is the output message of ‘List’ RPC.

object
errors
errors

Errors(if any) while listing items from collection.

Array<object>
ErrorType

Information about a error in API operation.

object
code
string
default: EOK
Allowed values: EOK EPERMS EBADINPUT ENOTFOUND EEXISTS EUNKNOWN ESERIALIZE EINTERNAL EPARTIAL
error_obj
object
type_url

A URL/resource name that uniquely identifies the type of the serialized protocol buffer message. This string must contain at least one ”/” character. The last segment of the URL’s path must represent the fully qualified name of the type (as in path/google.protobuf.duration). The name should be in a canonical form (e.g., leading ”.” is not accepted).

In practice, teams usually precompile into the binary all types that they expect it to use in the context of Any. However, for URLs which use the scheme HTTP, HTTPS, or no scheme, one can optionally set up a type server that maps type URLs to message definitions as follows:

  • If no scheme is provided, HTTPS is assumed.
  • An HTTP GET on the URL must yield a [google.protobuf.type][] value in binary format, or produce an error.
  • Applications are allowed to cache lookup results based on the URL, or have them precompiled into a binary to avoid any lookup. Therefore, binary compatibility needs to be preserved on changes to types. (Use versioned type names to manage breaking changes.)

Note: this functionality is not currently available in the official protobuf release, and it is not used for type URLs beginning with type.googleapis.com.

Schemes other than HTTP, HTTPS (or the empty scheme) might be used with implementation specific semantics.

string
<= 1024 characters
value

Must be a valid serialized protocol buffer of the above specified type.

string format: byte
>= 3 characters <= 1024 characters
message
message

A human readable string of the error.

string
<= 1024 characters
items
items

Items represents the collection in response.

Array<object>
ListResponseItem is an individual item in a collection of network_interface

By default a summary of network_interface is returned in ‘List’. By setting ‘report_fields’ in the ListRequest more details of each item can be got.

object
annotations
annotations

The set of annotations present on this network_interface.

object
description
description

The description set for this network_interface.

string
>= 21 characters <= 1024 characters
disabled
disabled

A value of true indicates network_interface is administratively disabled.

boolean format: boolean
get_spec
object
DHCP_server
string
default: NETWORK_INTERFACE_DHCP_SERVER_DISABLE
Allowed values: NETWORK_INTERFACE_DHCP_SERVER_DISABLE NETWORK_INTERFACE_DHCP_SERVER_ENABLE NETWORK_INTERFACE_ENHANCED_DHCP_SERVER_ENABLE
DNS_server
object
dns_mode
string
default: NETWORK_INTERFACE_DNS_DISABLE
Allowed values: NETWORK_INTERFACE_DNS_DISABLE NETWORK_INTERFACE_DNS_AUTO_ALLOCATE NETWORK_INTERFACE_DNS_USE_CONFIGURED
dns_server
DNS Server

Address of DNS server when mode is “use-configured”

Array<object>
IPv4 Address

IPv4 Address in dot-decimal notation.

object
addr
IPv4 Address

IPv4 Address in string form with dot-decimal notation.

string
<= 1024 characters
address_allocator

Reference to an address allocator for the network interface. When set, the allocator is used to allocate a subnet for the interface and an address from the subnet is set on the interface.

Array<object>
<= 1 items
ObjectRefType

This type establishes a ‘direct reference’ from one object(the referrer) to another(the referred). Such a reference is in form of tenant/namespace/name for public API and Uid for private API This type of reference is called direct because the relation is explicit and concrete (as opposed to selector reference which builds a group based on labels of selectee objects)

object
kind
kind

When a configuration object(e.g. Virtual_host) refers to another(e.g route) then kind will hold the referred object’s kind (e.g. “route”)

string
>= 12 characters <= 1024 characters
name
name

When a configuration object(e.g. Virtual_host) refers to another(e.g route) then name will hold the referred object’s(e.g. Route’s) name.

string
>= 6 characters <= 1024 characters
namespace
namespace

When a configuration object(e.g. Virtual_host) refers to another(e.g route) then namespace will hold the referred object’s(e.g. Route’s) namespace.

string
>= 6 characters <= 1024 characters
tenant
tenant

When a configuration object(e.g. Virtual_host) refers to another(e.g route) then tenant will hold the referred object’s(e.g. Route’s) tenant.

string
>= 6 characters <= 1024 characters
uid
uid

When a configuration object(e.g. Virtual_host) refers to another(e.g route) then uid will hold the referred object’s(e.g. Route’s) uid.

string format: uuid
>= 36 characters <= 1024 characters
dedicated_interface
object
cluster
object
device
Device

Name of the device for which interface is configured. Use wwan0 for 4G/LTE. Required: YES.

string
>= 1 characters <= 64 characters
is_primary
object
monitor
object
monitor_disabled
object
mtu
Maximum Packet Size (MTU)

Maximum packet size (Maximum Transfer Unit) of the interface When configured, MTU must be between 512 and 16384.

integer format: int64
node
Node

Exclusive with [cluster] Configuration will apply to a device on the given node of the site.

string
>= 1 characters <= 64 characters
not_primary
object
priority
Priority

Priority of the network interface when multiple network interfaces are present in outside network Greater the value, higher the priority.

integer format: int64
dedicated_management_interface
object
cluster
object
device
Device

Name of the device for which interface is configured Required: YES.

string
>= 1 characters <= 64 characters
mtu
Maximum Packet Size (MTU)

Maximum packet size (Maximum Transfer Unit) of the interface When configured, MTU must be between 512 and 16384.

integer format: int64
node
Node

Exclusive with [cluster] Configuration will apply to a device on the given node of the site.

string
>= 1 characters <= 64 characters
default_gateway
object
default_gateway_address
object
addr
IPv4 Address

IPv4 Address in string form with dot-decimal notation.

string
<= 1024 characters
default_gateway_mode
string
default: NETWORK_INTERFACE_GATEWAY_DISABLE
Allowed values: NETWORK_INTERFACE_GATEWAY_DISABLE NETWORK_INTERFACE_GATEWAY_AUTO_ALLOCATE NETWORK_INTERFACE_GATEWAY_USE_CONFIGURED
device_name

Name of the physical network interface device which this network interface represents. Required: YES.

string
<= 1024 characters
dhcp_address
string
default: NETWORK_INTERFACE_DHCP_DISABLE
Allowed values: NETWORK_INTERFACE_DHCP_DISABLE NETWORK_INTERFACE_DHCP_ENABLE
ethernet_interface
object
cluster
object
device
Device

Interface configuration for the ethernet device Required: YES.

string
>= 1 characters <= 64 characters
dhcp_client
object
dhcp_server
object
automatic_from_end
object
automatic_from_start
object
dhcp_networks
DHCP Networks

List of networks from which DHCP Server can allocate IPv4 Addresses

Required: YES.

Array<object>
>= 1 items <= 1 items
DHCP Network

DHCP network configuration.

object
dgw_address
Configured Address

Exclusive with [first_address last_address] Enter a IPv4 address from the network prefix to be used as the default gateway.

string
<= 1024 characters
dns_address
Configured Address

Exclusive with [same_as_dgw] Enter a IPv4 address from the network prefix to be used as the DNS server.

string
<= 1024 characters
first_address
object
last_address
object
network_prefix
Network Prefix

Exclusive with [] Set the network prefix for the site. Ex: 10.1.1.0/24.

string
<= 1024 characters
pool_settings
string
default: INCLUDE_IP_ADDRESSES_FROM_DHCP_POOLS
Allowed values: INCLUDE_IP_ADDRESSES_FROM_DHCP_POOLS EXCLUDE_IP_ADDRESSES_FROM_DHCP_POOLS
pools
DHCP pools

List of non overlapping IP address ranges.

Array<object>
<= 16 items
DHCP IP Range

DHCP pool is a range of IP addresses (start IP and end IP).

object
end_ip
End IP

Ending IP of the pool range. In case of address allocator, offset is derived based on network prefix. 10.1.1.200 with prefix length of 24, end offset is 0.0.0.200.

string
<= 1024 characters
start_ip
Start IP

Starting IP of the pool range. In case of address allocator, offset is derived based on network prefix. 10.1.1.5 with prefix length of 24, start offset is 0.0.0.5.

string
<= 1024 characters
same_as_dgw
object
fixed_ip_map
Fixed IP Assignments

Assign fixed IPv4 addresses based on the MAC Address of the DHCP Client.

object
interface_ip_map
object
interface_ip_map
Site:Node to IP mapping

Specify static IPv4 addresses per site:node.

object
ipv6_auto_config
object
host
object
router
object
dns_config
object
configured_list
object
dns_list
Dns List

List of IPv6 Addresses acting as DNS servers Required: YES.

Array<string>
>= 1 items <= 4 items
local_dns
object
configured_address
Configured Address

Exclusive with [first_address last_address] Configured address from the network prefix is chosen as DNS server.

string
<= 1024 characters
first_address
object
last_address
object
network_prefix
Prefix Info

Exclusive with [stateful] Nework prefix that is used as Prefix information Allowed only /64 prefix length as per RFC 4862.

string
<= 1024 characters
stateful
object
automatic_from_end
object
automatic_from_start
object
dhcp_networks
DHCP IPV6 Networks

List of networks from which DHCP server can allocate IP addresses

Required: YES.

Array<object>
>= 1 items <= 1 items
DHCPIPV6NetworkType

DHCP IPv6 network type configuration.

object
network_prefix
Network Prefix

Exclusive with [] Network Prefix to be used for IPv6 address auto configuration.

string
<= 1024 characters
pool_settings
string
default: INCLUDE_IP_ADDRESSES_FROM_DHCP_POOLS
Allowed values: INCLUDE_IP_ADDRESSES_FROM_DHCP_POOLS EXCLUDE_IP_ADDRESSES_FROM_DHCP_POOLS
pools
DHCP pools

List of non overlapping IP address ranges.

Array<object>
<= 16 items
DHCP IPV6 Range

DHCP IPv6 pool is a range of IP addresses (start IP and end IP).

object
end_ip
End IP

Ending IPv6 address of the pool range. In case of address allocator, offset is derived based on network prefix.

string
<= 1024 characters
start_ip
Start IPV6

Starting IPv6 address of the pool range. In case of address allocator, offset is derived based on network prefix. 2001::1 with prefix length of 64, start offset is 5.

string
<= 1024 characters
fixed_ip_map
Fixed IPV6 Assignments

Fixed MAC address to IPv6 assignments, Key: MAC address, Value: IPv6 Address Assign fixed IPv6 addresses based on the MAC Address of the DHCP Client.

object
interface_ip_map
object
interface_ip_map
Site:Node to IPV6 mapping

Map of Site:Node to IPv6 address.

object
is_primary
object
monitor
object
monitor_disabled
object
mtu
Maximum Packet Size (MTU)

Maximum packet size (Maximum Transfer Unit) of the interface When configured, MTU must be between 512 and 16384.

integer format: int64
no_ipv6_address
object
node
Node

Exclusive with [cluster] Configuration will apply to a device on the given node.

string
>= 1 characters <= 64 characters
not_primary
object
priority
Priority

Priority of the network interface when multiple network interfaces are present in outside network Greater the value, higher the priority.

integer format: int64
site_local_inside_network
object
site_local_network
object
static_ip
object
cluster_static_ip
object
interface_ip_map
Site:Node to IP mapping

Map of Node to Static IP configuration value, Key:Node, Value:IP Address.

object
node_static_ip
object
default_gw
Default Gateway

IP address of the default gateway.

string
<= 1024 characters
ip_address
Default Gateway

IP address of the interface and prefix length Required: YES.

string
<= 1024 characters
static_ipv6_address
object
cluster_static_ip
object
interface_ip_map
Site:Node to IP mapping

Map of Node to Static IP configuration value, Key:Node, Value:IP Address.

object
node_static_ip
object
default_gw
Default Gateway

IP address of the default gateway.

string
<= 1024 characters
ip_address
Default Gateway

IP address of the interface and prefix length Required: YES.

string
<= 1024 characters
storage_network
object
untagged
object
vlan_id
VLAN Id

Exclusive with [untagged] Configure a VLAN tagged ethernet interface.

integer format: int64
>= 1 <= 4094
interface_ip_map

Map of Site:Node to IP address offset. Key:Node, Value:Map Value of 10.1.1.5 with network prefix 24, offset is 0.0.0.5.

object
is_primary

This interface is primary interface.

boolean format: boolean
layer2_interface
object
l2sriov_interface
object
device
Device

Physical ethernet interface Required: YES.

string
>= 1 characters <= 64 characters
untagged
object
vlan_id
VLAN Id

Exclusive with [untagged] Configure a VLAN tagged interface.

integer format: int64
>= 1 <= 4094
l2vlan_interface
object
device
Device

Physical ethernet interface Required: YES.

string
>= 1 characters <= 64 characters
vlan_id
VLAN Id

VLAN ID Required: YES.

integer format: int64
>= 1 <= 4094
l2vlan_slo_interface
object
vlan_id
VLAN Id

VLAN ID Required: YES.

integer format: int64
>= 1 <= 4094
legacy_interface
object
DHCP_server
string
default: NETWORK_INTERFACE_DHCP_SERVER_DISABLE
Allowed values: NETWORK_INTERFACE_DHCP_SERVER_DISABLE NETWORK_INTERFACE_DHCP_SERVER_ENABLE NETWORK_INTERFACE_ENHANCED_DHCP_SERVER_ENABLE
DNS_server
object
dns_mode
string
default: NETWORK_INTERFACE_DNS_DISABLE
Allowed values: NETWORK_INTERFACE_DNS_DISABLE NETWORK_INTERFACE_DNS_AUTO_ALLOCATE NETWORK_INTERFACE_DNS_USE_CONFIGURED
dns_server
DNS Server

Address of DNS server when mode is “use-configured”

Array<object>
IPv4 Address

IPv4 Address in dot-decimal notation.

object
addr
IPv4 Address

IPv4 Address in string form with dot-decimal notation.

string
<= 1024 characters
address_allocator
Address Allocator

Reference to an address allocator for the network interface. When set, the allocator is used to allocate a subnet for the interface and an address from the subnet is set on the interface.

Array<object>
<= 1 items
ObjectRefType

This type establishes a ‘direct reference’ from one object(the referrer) to another(the referred). Such a reference is in form of tenant/namespace/name for public API and Uid for private API This type of reference is called direct because the relation is explicit and concrete (as opposed to selector reference which builds a group based on labels of selectee objects)

object
kind
kind

When a configuration object(e.g. Virtual_host) refers to another(e.g route) then kind will hold the referred object’s kind (e.g. “route”)

string
>= 12 characters <= 1024 characters
name
name

When a configuration object(e.g. Virtual_host) refers to another(e.g route) then name will hold the referred object’s(e.g. Route’s) name.

string
>= 6 characters <= 1024 characters
namespace
namespace

When a configuration object(e.g. Virtual_host) refers to another(e.g route) then namespace will hold the referred object’s(e.g. Route’s) namespace.

string
>= 6 characters <= 1024 characters
tenant
tenant

When a configuration object(e.g. Virtual_host) refers to another(e.g route) then tenant will hold the referred object’s(e.g. Route’s) tenant.

string
>= 6 characters <= 1024 characters
uid
uid

When a configuration object(e.g. Virtual_host) refers to another(e.g route) then uid will hold the referred object’s(e.g. Route’s) uid.

string format: uuid
>= 36 characters <= 1024 characters
default_gateway
object
default_gateway_address
object
addr
IPv4 Address

IPv4 Address in string form with dot-decimal notation.

string
<= 1024 characters
default_gateway_mode
string
default: NETWORK_INTERFACE_GATEWAY_DISABLE
Allowed values: NETWORK_INTERFACE_GATEWAY_DISABLE NETWORK_INTERFACE_GATEWAY_AUTO_ALLOCATE NETWORK_INTERFACE_GATEWAY_USE_CONFIGURED
device_name
Device Name

Name of the physical network interface device which this network interface represents. Required: YES.

string
<= 1024 characters
dhcp_address
string
default: NETWORK_INTERFACE_DHCP_DISABLE
Allowed values: NETWORK_INTERFACE_DHCP_DISABLE NETWORK_INTERFACE_DHCP_ENABLE
monitor
object
monitor_disabled
object
mtu
Mtu

Maximum Transfer Unit (Max packet length) of the interface When configured, MTU must be between 512 and 16384.

integer format: int64
priority
Priority

Priority of the network interface when multiple network interfaces are present in the fleet object Greater the value, higher the priority.

integer format: int64
static_addresses
Static IP

If DHCP server is enabled, configures the subnet to be used for IP allocation.

Array<object>
IPv4 Subnet

IPv4 subnets specified as prefix and prefix-length. Prefix length must be <= 32.

object
plen
Prefix Length

Prefix-length of the IPv4 subnet. Must be <= 32.

integer format: int64
prefix
Prefix

Prefix part of the IPv4 subnet in string form with dot-decimal notation.

string
<= 1024 characters
tunnel
object
tunnel
Tunnel

Tunnel which is attached to this interface.

Array<object>
<= 1 items
ObjectRefType

This type establishes a ‘direct reference’ from one object(the referrer) to another(the referred). Such a reference is in form of tenant/namespace/name for public API and Uid for private API This type of reference is called direct because the relation is explicit and concrete (as opposed to selector reference which builds a group based on labels of selectee objects)

object
kind
kind

When a configuration object(e.g. Virtual_host) refers to another(e.g route) then kind will hold the referred object’s kind (e.g. “route”)

string
>= 12 characters <= 1024 characters
name
name

When a configuration object(e.g. Virtual_host) refers to another(e.g route) then name will hold the referred object’s(e.g. Route’s) name.

string
>= 6 characters <= 1024 characters
namespace
namespace

When a configuration object(e.g. Virtual_host) refers to another(e.g route) then namespace will hold the referred object’s(e.g. Route’s) namespace.

string
>= 6 characters <= 1024 characters
tenant
tenant

When a configuration object(e.g. Virtual_host) refers to another(e.g route) then tenant will hold the referred object’s(e.g. Route’s) tenant.

string
>= 6 characters <= 1024 characters
uid
uid

When a configuration object(e.g. Virtual_host) refers to another(e.g route) then uid will hold the referred object’s(e.g. Route’s) uid.

string format: uuid
>= 36 characters <= 1024 characters
type
string
default: NETWORK_INTERFACE_ETHERNET
Allowed values: NETWORK_INTERFACE_ETHERNET NETWORK_INTERFACE_VLAN_INTERFACE NETWORK_INTERFACE_LACP_INTERFACE NETWORK_INTERFACE_TUNNEL_INTERFACE NETWORK_INTERFACE_LOOPBACK_INTERFACE NETWORK_INTERFACE_LAYER2_INTERFACE
virtual_network
Virtual Network

Virtual-network for the interface This is optional and can contain at most one entry.

Array<object>
<= 1 items
ObjectRefType

This type establishes a ‘direct reference’ from one object(the referrer) to another(the referred). Such a reference is in form of tenant/namespace/name for public API and Uid for private API This type of reference is called direct because the relation is explicit and concrete (as opposed to selector reference which builds a group based on labels of selectee objects)

object
kind
kind

When a configuration object(e.g. Virtual_host) refers to another(e.g route) then kind will hold the referred object’s kind (e.g. “route”)

string
>= 12 characters <= 1024 characters
name
name

When a configuration object(e.g. Virtual_host) refers to another(e.g route) then name will hold the referred object’s(e.g. Route’s) name.

string
>= 6 characters <= 1024 characters
namespace
namespace

When a configuration object(e.g. Virtual_host) refers to another(e.g route) then namespace will hold the referred object’s(e.g. Route’s) namespace.

string
>= 6 characters <= 1024 characters
tenant
tenant

When a configuration object(e.g. Virtual_host) refers to another(e.g route) then tenant will hold the referred object’s(e.g. Route’s) tenant.

string
>= 6 characters <= 1024 characters
uid
uid

When a configuration object(e.g. Virtual_host) refers to another(e.g route) then uid will hold the referred object’s(e.g. Route’s) uid.

string format: uuid
>= 36 characters <= 1024 characters
vlan_tag
Vlan Tag

VLAN tag of the interface, valid only if VLAN tagging is enabled when vlan_tagging is enabled, value must be between 1 - 4094.

integer format: int64
vlan_tagging
string
default: NETWORK_INTERFACE_VLAN_TAGGING_DISABLE
Allowed values: NETWORK_INTERFACE_VLAN_TAGGING_DISABLE NETWORK_INTERFACE_VLAN_TAGGING_ENABLE
monitor
object
monitor_disabled
object
mtu

Maximum Transfer Unit (Max packet length) of the interface When configured, MTU must be between 512 and 16384.

integer format: int64
priority

Priority of the network interface when multiple network interfaces are present in the fleet object Greater the value, higher the priority.

integer format: int64
static_addresses

If DHCP server is enabled, configures the subnet to be used for IP allocation.

Array<object>
<= 16 items
IPv4 Subnet

IPv4 subnets specified as prefix and prefix-length. Prefix length must be <= 32.

object
plen
Prefix Length

Prefix-length of the IPv4 subnet. Must be <= 32.

integer format: int64
prefix
Prefix

Prefix part of the IPv4 subnet in string form with dot-decimal notation.

string
<= 1024 characters
tunnel
object
tunnel
Tunnel

Tunnel which is attached to this interface.

Array<object>
<= 1 items
ObjectRefType

This type establishes a ‘direct reference’ from one object(the referrer) to another(the referred). Such a reference is in form of tenant/namespace/name for public API and Uid for private API This type of reference is called direct because the relation is explicit and concrete (as opposed to selector reference which builds a group based on labels of selectee objects)

object
kind
kind

When a configuration object(e.g. Virtual_host) refers to another(e.g route) then kind will hold the referred object’s kind (e.g. “route”)

string
>= 12 characters <= 1024 characters
name
name

When a configuration object(e.g. Virtual_host) refers to another(e.g route) then name will hold the referred object’s(e.g. Route’s) name.

string
>= 6 characters <= 1024 characters
namespace
namespace

When a configuration object(e.g. Virtual_host) refers to another(e.g route) then namespace will hold the referred object’s(e.g. Route’s) namespace.

string
>= 6 characters <= 1024 characters
tenant
tenant

When a configuration object(e.g. Virtual_host) refers to another(e.g route) then tenant will hold the referred object’s(e.g. Route’s) tenant.

string
>= 6 characters <= 1024 characters
uid
uid

When a configuration object(e.g. Virtual_host) refers to another(e.g route) then uid will hold the referred object’s(e.g. Route’s) uid.

string format: uuid
>= 36 characters <= 1024 characters
tunnel_interface
object
mtu
Maximum Packet Size (MTU)

Maximum packet size (Maximum Transfer Unit) of the interface When configured, MTU must be between 512 and 16384.

integer format: int64
node
Node

Exclusive with [] Configuration will apply to a given device on the given node.

string
>= 1 characters <= 64 characters
priority
Priority

Priority of the network interface when multiple network interfaces are present in outside network Greater the value, higher the priority.

integer format: int64
site_local_inside_network
object
site_local_network
object
static_ip
object
cluster_static_ip
object
interface_ip_map
Site:Node to IP mapping

Map of Node to Static IP configuration value, Key:Node, Value:IP Address.

object
node_static_ip
object
default_gw
Default Gateway

IP address of the default gateway.

string
<= 1024 characters
ip_address
Default Gateway

IP address of the interface and prefix length Required: YES.

string
<= 1024 characters
tunnel
object
name
name

When a configuration object(e.g. Virtual_host) refers to another(e.g route) then name will hold the referred object’s(e.g. Route’s) name. Required: YES.

string
>= 1 characters <= 128 characters
namespace
namespace

When a configuration object(e.g. Virtual_host) refers to another(e.g route) then namespace will hold the referred object’s(e.g. Route’s) namespace.

string
>= 6 characters <= 64 characters
tenant
tenant

When a configuration object(e.g. Virtual_host) refers to another(e.g route) then tenant will hold the referred object’s(e.g. Route’s) tenant.

string
>= 6 characters <= 64 characters
type
string
default: NETWORK_INTERFACE_ETHERNET
Allowed values: NETWORK_INTERFACE_ETHERNET NETWORK_INTERFACE_VLAN_INTERFACE NETWORK_INTERFACE_LACP_INTERFACE NETWORK_INTERFACE_TUNNEL_INTERFACE NETWORK_INTERFACE_LOOPBACK_INTERFACE NETWORK_INTERFACE_LAYER2_INTERFACE
virtual_network

Virtual-network for the interface This is optional and can contain at most one entry.

Array<object>
<= 1 items
ObjectRefType

This type establishes a ‘direct reference’ from one object(the referrer) to another(the referred). Such a reference is in form of tenant/namespace/name for public API and Uid for private API This type of reference is called direct because the relation is explicit and concrete (as opposed to selector reference which builds a group based on labels of selectee objects)

object
kind
kind

When a configuration object(e.g. Virtual_host) refers to another(e.g route) then kind will hold the referred object’s kind (e.g. “route”)

string
>= 12 characters <= 1024 characters
name
name

When a configuration object(e.g. Virtual_host) refers to another(e.g route) then name will hold the referred object’s(e.g. Route’s) name.

string
>= 6 characters <= 1024 characters
namespace
namespace

When a configuration object(e.g. Virtual_host) refers to another(e.g route) then namespace will hold the referred object’s(e.g. Route’s) namespace.

string
>= 6 characters <= 1024 characters
tenant
tenant

When a configuration object(e.g. Virtual_host) refers to another(e.g route) then tenant will hold the referred object’s(e.g. Route’s) tenant.

string
>= 6 characters <= 1024 characters
uid
uid

When a configuration object(e.g. Virtual_host) refers to another(e.g route) then uid will hold the referred object’s(e.g. Route’s) uid.

string format: uuid
>= 36 characters <= 1024 characters
vlan_tag

VLAN tag of the interface, valid only if VLAN tagging is enabled when vlan_tagging is enabled, value must be between 1 - 4094.

integer format: int64
vlan_tagging
string
default: NETWORK_INTERFACE_VLAN_TAGGING_DISABLE
Allowed values: NETWORK_INTERFACE_VLAN_TAGGING_DISABLE NETWORK_INTERFACE_VLAN_TAGGING_ENABLE
labels
labels

The set of labels present on this network_interface.

object
metadata
object
annotations
annotations

Annotations is an unstructured key value map stored with a resource that may be set by external tools to store and retrieve arbitrary metadata. They are not queryable and should be preserved when modifying objects.

object
description
description

Human readable description for the object.

string
>= 21 characters <= 1200 characters
disable
disable

A value of true will administratively disable the object.

boolean format: boolean
labels
labels

Map of string keys and values that can be used to organize and categorize (scope and select) objects as chosen by the user. Values specified here will be used by selector expression.

object
name
name

This is the name of configuration object. It has to be unique within the namespace. It can only be specified during create API and cannot be changed during replace API. The value of name has to follow DNS-1035 format. Required: YES.

string
>= 6 characters <= 1024 characters
namespace
namespace

This defines the workspace within which each the configuration object is to be created. Must be a DNS_LABEL format. For a namespace object itself, namespace value will be ""

string
>= 6 characters <= 1024 characters
name
name

The name of this network_interface.

string
>= 6 characters <= 1024 characters
namespace
namespace

The namespace this item belongs to.

string
>= 6 characters <= 1024 characters
owner_view
object
kind
kind

Kind of the view object.

string
>= 12 characters <= 1024 characters
name
name

When a configuration object(e.g. Virtual_host) refers to another(e.g route) then name will hold the referred object’s(e.g. Route’s) name.

string
>= 6 characters <= 1024 characters
namespace
namespace

When a configuration object(e.g. Virtual_host) refers to another(e.g route) then namespace will hold the referred object’s(e.g. Route’s) namespace.

string
>= 6 characters <= 1024 characters
uid
uid

UID of the view object.

string format: uuid
>= 36 characters <= 1024 characters
status_set
status

The status reported by different services for this configuration object.

Array<object>
Network Interface Status

Most recently observed status of object.

object
conditions
conditions

Conditions reported by various components of the system.

Array<object>
ConditionType

Conditions are used in the object status to describe the current state of the object, e.g. Ready, Succeeded, etc.

object
hostname
hostname

Hostname of the instance of the site that sent the status.

string
<= 1024 characters
last_update_time
last_update_time

Last time the condition was updated.

string format: date-time
<= 1024 characters
reason
reason

X-reason: “Insufficient memory in data plane” A human readable string explaining the reason for reaching this condition.

string
>= 27 characters <= 1024 characters
service_name
service name

Name of the service that sent the status.

string
<= 1024 characters
status
status

Status of the condition “Success” Validtion has succeded. Requested operation was successful. “Failed” Validation has failed. “Incomplete” Validation of configuration has failed due to missing configuration. “Installed” Validation has passed and configuration has been installed in data path or K8s “Down” Configuration is operationally down. E.g. Down interface “Disabled” Configuration is administratively disabled i.e. objectmetatype.disable = true. “NotApplicable” Configuration is not applicable e.g. Tenant service_policy_set(s) in system namespace are not applicable on REs.

string
>= 17 characters <= 1024 characters
type
type

Type of the condition “Validation” represents validation user given configuration object “Operational” represents operational status of a given configuration object.

string
<= 1024 characters
metadata
object
creation_timestamp
creation_timestamp

Creation_timestamp is when the status object was created. It is used to find/tie-break for latest status object from same origin.

string format: date-time
<= 1024 characters
creator_class
creator_class

Class of creator which created this StatusObject. This will be service’s DNS FQDN. This will be set by the system based on client certificate information.

string
<= 1024 characters
creator_id
creator_id

ID of creator which created this StatusObject. This will be a concrete identifier for service (e.g. Identifying the environment also). This will be set by the system based on client certificate information.

string
<= 1024 characters
publish
string
default: STATUS_DO_NOT_PUBLISH
Allowed values: STATUS_DO_NOT_PUBLISH STATUS_PUBLISH
status_id
status_id

Status_id is a field used by the generator to distinguish (if necessary) between two status objects for the same config object from the same site and same service and potentially same daemon(creator-ID)

string
<= 1024 characters
uid
uid

Uid is the unique in time and space value for a StatusObject.

string format: uuid
>= 36 characters <= 1024 characters
vtrp_id
vtrp_id

Origin of this status exchanged by VTRP.

string
<= 1024 characters
vtrp_stale
vtrp_stale

Indicate whether mars deems this object to be stale via graceful restart timer information.

boolean format: boolean
object_refs
object_refs

Reference to object for current status.

Array<object>
ObjectRefType

This type establishes a ‘direct reference’ from one object(the referrer) to another(the referred). Such a reference is in form of tenant/namespace/name for public API and Uid for private API This type of reference is called direct because the relation is explicit and concrete (as opposed to selector reference which builds a group based on labels of selectee objects)

object
kind
kind

When a configuration object(e.g. Virtual_host) refers to another(e.g route) then kind will hold the referred object’s kind (e.g. “route”)

string
>= 12 characters <= 1024 characters
name
name

When a configuration object(e.g. Virtual_host) refers to another(e.g route) then name will hold the referred object’s(e.g. Route’s) name.

string
>= 6 characters <= 1024 characters
namespace
namespace

When a configuration object(e.g. Virtual_host) refers to another(e.g route) then namespace will hold the referred object’s(e.g. Route’s) namespace.

string
>= 6 characters <= 1024 characters
tenant
tenant

When a configuration object(e.g. Virtual_host) refers to another(e.g route) then tenant will hold the referred object’s(e.g. Route’s) tenant.

string
>= 6 characters <= 1024 characters
uid
uid

When a configuration object(e.g. Virtual_host) refers to another(e.g route) then uid will hold the referred object’s(e.g. Route’s) uid.

string format: uuid
>= 36 characters <= 1024 characters
status
object
up_down
string
default: NETWORK_INTERFACE_ADMINISTRATIVELY_DOWN
Allowed values: NETWORK_INTERFACE_ADMINISTRATIVELY_DOWN NETWORK_INTERFACE_OPERATIONALY_DOWN NETWORK_INTERFACE_OPERATIONALY_UP
system_metadata
object
creation_timestamp
creation_timestamp

CreationTimestamp is a timestamp representing the server time when this object was created. It is not guaranteed to be set in happens-before order across separate operations. Clients may not set this value. It is represented in RFC3339 form and is in UTC.

string format: date-time
<= 1024 characters
creator_class
creator_class

A value identifying the class of the user or service which created this configuration object.

string
<= 1024 characters
creator_id
creator_id

A value identifying the exact user or service that created this configuration object.

string
<= 1024 characters
deletion_timestamp
deletion_timestamp

DeletionTimestamp is RFC 3339 date and time at which this resource will be deleted. This field is set by the server when a graceful deletion is requested by the user, and is not directly settable by a client. The resource is expected to be deleted (no longer visible from resource lists, and not reachable by name) after the time in this field, once the finalizers list is empty. As long as the finalizers list contains items, deletion is blocked. Once the deletionTimestamp is set, this value may not be unset or be set further into the future, although it may be shortened or the resource may be deleted prior to this time. For example, a user may request that a pod is deleted in 30 seconds. The Kubelet will react by sending a graceful termination signal to the containers in the pod. After that 30 seconds, the Kubelet will send a hard termination signal (SIGKILL) to the container and after cleanup, remove the pod from the API. In the presence of network partitions, this object may still exist after this timestamp, until an administrator or automated process can determine the resource is fully terminated. If not set, graceful deletion of the object has not been requested.

Populated by the system when a graceful deletion is requested. Read-only.

string format: date-time
<= 1024 characters
finalizers
finalizers

Must be empty before the object is deleted from the registry. Each entry is an identifier for the responsible component that will remove the entry from the list. If the deletionTimestamp of the object is non-nil, entries in this list can only be removed.

Array<string>
initializers
object
pending
pending

Pending is a list of initializers that must execute in order before this object is initialized. When the last pending initializer is removed, and no failing result is set, the initializers struct will be set to nil and the object is considered as initialized and visible to all clients.

Array<object>
InitializerType

Initializer is information about an initializer that has not yet completed.

object
name
name

Name of the service that is responsible for initializing this object.

string
>= 6 characters <= 1024 characters
result
object
code
code

Suggested HTTP return code for this status, 0 if not set.

integer format: int32
reason
reason

A human-readable description of why this operation is in the “Failure” status. If this value is empty there is no information available.

string
>= 27 characters <= 1024 characters
status
status

Status of the operation. One of: “Success” or “Failure”.

string
>= 17 characters <= 1024 characters
labels
labels

Map of string keys and values that can be used to organize and categorize (scope and select) objects as chosen by the operator or software. Values here can be interpreted by software(backend or frontend) to enable certain behavior e.g. Things marked as soft-deleted(restorable).

object
modification_timestamp
modification_timestamp

ModificationTimestamp is a timestamp representing the server time when this object was last modified.

string format: date-time
<= 1024 characters
object_index
object_index

Unique index for the object. Some objects need a unique integer index to be allocated for each object type. This field will be populated for all objects that need it and will be zero otherwise.

integer format: int64
owner_view
object
kind
kind

Kind of the view object.

string
>= 12 characters <= 1024 characters
name
name

When a configuration object(e.g. Virtual_host) refers to another(e.g route) then name will hold the referred object’s(e.g. Route’s) name.

string
>= 6 characters <= 1024 characters
namespace
namespace

When a configuration object(e.g. Virtual_host) refers to another(e.g route) then namespace will hold the referred object’s(e.g. Route’s) namespace.

string
>= 6 characters <= 1024 characters
uid
uid

UID of the view object.

string format: uuid
>= 36 characters <= 1024 characters
tenant
tenant

Tenant to which this configuration object belongs to. The value for this is found from presented credentials.

string
>= 6 characters <= 1024 characters
uid
uid

Uid is the unique in time and space value for this object. It is generated by the server on successful creation of an object and is not allowed to change on Replace API. The value of is taken from uid field of ObjectMetaType, if provided.

string format: uuid
>= 36 characters <= 1024 characters
tenant
tenant

The tenant this item belongs to.

string
>= 6 characters <= 1024 characters
uid
uid

The unique uid of this network_interface.

string format: uuid
>= 36 characters <= 1024 characters
Example
{
"errors": [
{
"code": "EOK"
}
],
"items": [
{
"get_spec": {
"DHCP_server": "NETWORK_INTERFACE_DHCP_SERVER_DISABLE",
"DNS_server": {
"dns_mode": "NETWORK_INTERFACE_DNS_DISABLE"
},
"default_gateway": {
"default_gateway_mode": "NETWORK_INTERFACE_GATEWAY_DISABLE"
},
"dhcp_address": "NETWORK_INTERFACE_DHCP_DISABLE",
"ethernet_interface": {
"dhcp_server": {
"dhcp_networks": [
{
"pool_settings": "INCLUDE_IP_ADDRESSES_FROM_DHCP_POOLS"
}
]
},
"ipv6_auto_config": {
"router": {
"stateful": {
"dhcp_networks": [
{
"pool_settings": "INCLUDE_IP_ADDRESSES_FROM_DHCP_POOLS"
}
]
}
}
}
},
"legacy_interface": {
"DHCP_server": "NETWORK_INTERFACE_DHCP_SERVER_DISABLE",
"DNS_server": {
"dns_mode": "NETWORK_INTERFACE_DNS_DISABLE"
},
"default_gateway": {
"default_gateway_mode": "NETWORK_INTERFACE_GATEWAY_DISABLE"
},
"dhcp_address": "NETWORK_INTERFACE_DHCP_DISABLE",
"type": "NETWORK_INTERFACE_ETHERNET",
"vlan_tagging": "NETWORK_INTERFACE_VLAN_TAGGING_DISABLE"
},
"type": "NETWORK_INTERFACE_ETHERNET",
"vlan_tagging": "NETWORK_INTERFACE_VLAN_TAGGING_DISABLE"
},
"status_set": [
{
"metadata": {
"publish": "STATUS_DO_NOT_PUBLISH"
},
"status": {
"up_down": "NETWORK_INTERFACE_ADMINISTRATIVELY_DOWN"
}
}
]
}
]
}

Returned when operation is not authorized.

Media typeapplication/json
string format: string
Examplegenerated
example

Returned when there is no permission to access resource.

Media typeapplication/json
string format: string
Examplegenerated
example

Returned when resource is not found.

Media typeapplication/json
string format: string
Examplegenerated
example

Returned when operation on resource is conflicting with current value.

Media typeapplication/json
string format: string
Examplegenerated
example

Returned when operation has been rejected as it is happening too frequently.

Media typeapplication/json
string format: string
Examplegenerated
example

Returned when server encountered an error in processing API.

Media typeapplication/json
string format: string
Examplegenerated
example

Returned when service is unavailable temporarily.

Media typeapplication/json
string format: string
Examplegenerated
example

Returned when server timed out processing request.

Media typeapplication/json
string format: string
Examplegenerated
example